unit m41u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TKontrola = class(TForm)
    EVstup: TEdit;
    EVystup: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const max_ign = 100;

type TTyp = (slovo,znamenka);
     TSlovo = record {sem se budou ukladat slova, poitry jsou odkazy na dalsi zaznamy; celkova velikost cca. 5.25 MB}
                sl: shortstring;
                predchozi,dalsi: pointer;
              end;

var
  Kontrola: TKontrola;
  prvni: ^TSlovo;
  vstup, vystup: text;
  ignorace: array[1..max_ign] of string;
  akt_ign: integer;
  slovnik_zmenen: boolean = false;
  nalezena_chyba: boolean;
  nejlepsi: array[1..10] of record
                              tvar: string;
                              hodnoceni: integer;
                            end;
  pocet_nej: integer;

{function nalezeno(co: string): boolean;}
procedure zkontroluj(svstup,svystup: string);
procedure nacti_slovnik; {nacte slovnik do pameti}
procedure zrus_slovnik;

implementation

uses m41uo, m41uinfo;

{$R *.DFM}

function sekej(co: string; var kde: integer; var kus: string; var typ: TTyp): boolean; {seka zadany string na slova a neslova}
begin
  kus:='';
  if kde>length(co) then begin sekej:=false; exit; end else sekej:=true;
  if ansilowercase(co[kde])=ansiuppercase(co[kde]) then
  begin
    repeat
      kus:=kus+co[kde];
      inc(kde);
    until (ansilowercase(co[kde])<>ansiuppercase(co[kde])) or (kde>length(co));
    typ:=znamenka;
  end else
  begin
    repeat
      kus:=kus+co[kde];
      inc(kde);
    until (ansilowercase(co[kde])=ansiuppercase(co[kde])) or (kde>length(co));
    typ:=slovo;
  end;
end;

function vytvor_slovo(slovo: string; predchozi: pointer): pointer; {vytvori pamet pro slovo a ulozi jej}
var sl: ^TSlovo;
begin
  getmem(sl,sizeof(TSlovo));
  sl^.sl:=slovo;
  sl^.predchozi:=predchozi;
  vytvor_slovo:=sl;
end;

function nacti_slovo(var sl: pointer): string; {nacte slovo a posune pointer}
var slovo: ^TSlovo;
begin
  slovo:=sl;
  result:=slovo^.sl;
  sl:=slovo^.dalsi;
end;

procedure nacti_slovnik; {nacte slovnik do pameti}
var zacatek: boolean;
    min,tmp: ^Tslovo;
    pozice: integer;
    s: string;
    slovnik: text;
    pocet: integer;
begin
  assign (slovnik,'dict.txt');
  reset(slovnik);
  zacatek:=true;
  pocet:=0;
  while not eof(slovnik) {and (pocet<10)} do
  begin
    readln(slovnik,s);
    pozice:=pos('/',s);
    inc(pocet);
    if pozice<>0 then s:=copy(s,1,pozice-1);
    if zacatek then
    begin
      prvni:=vytvor_slovo(s,nil);
      min:=pointer(prvni);
      zacatek:=false;
    end else
    begin
      tmp:=vytvor_slovo(s,min);
      min^.dalsi:=tmp;
      min:=tmp;
    end;
  end;
  if min<>nil then min^.dalsi:=nil;
  system.close(slovnik);
end;

procedure zrus_slovnik;
var sltmp: ^TSlovo;
    p: pointer;
begin
  p:=pointer(prvni);
  if p=nil then exit;
  repeat
    sltmp:=p;
    nacti_slovo(p);
    freemem(sltmp,sizeof(TSlovo));
  until p=nil;
end;

procedure pridej_slovo(ktere: string); {abecedne zaradi slovo do retezce zaznamu}
var p: pointer;
    pred,za,nove: ^TSlovo;
    s: string;
begin
  slovnik_zmenen:=true;
  p:=pointer(prvni);
  if p=nil then exit;
  repeat
    za:=p;
    s:=nacti_slovo(p);
    if ktere<s then
    begin
      pred:=za^.predchozi;
      if pred=nil then
      begin {pokud je na zacatku abecedy}
        nove:=vytvor_slovo(ktere,nil);
        nove^.dalsi:=za;
        za^.predchozi:=nove;
        prvni:=pointer(nove);
      end else
      begin {pokud je uprestred}
        nove:=vytvor_slovo(ktere,pred);
        nove^.dalsi:=za;
        za^.predchozi:=nove;
        pred^.dalsi:=nove;
      end;
      exit;
    end;
  until p=nil;
  nove:=vytvor_slovo(ktere,za); {pokud je az na konci abecedy}
  za^.dalsi:=nove;
  nove^.dalsi:=nil;
end;

procedure zapis_slovnik; {hodi slovnik na disk}
var p: pointer;
    slovnik: text;
    slovo: string;
begin
  assign(slovnik,'dict.txt');
  rewrite(slovnik);
  p:=pointer(prvni);
  if p=nil then exit;
  repeat
    slovo:=nacti_slovo(p);
    writeln(slovnik,slovo);
  until p=nil;
  system.close(slovnik);
end;

procedure vloz(co: string; hodnoceni,kam: integer);
var a: integer;
begin
  for a:=pocet_nej downto kam do if a<10 then nejlepsi[a+1]:=nejlepsi[a];
  nejlepsi[kam].tvar:=co;
  nejlepsi[kam].hodnoceni:=hodnoceni;
  if pocet_nej<10 then inc(pocet_nej);
end;

procedure pridej_nejlepsi(nalezeno, hledano: string);
var a,delka,hodnoceni: integer;
begin
  hodnoceni:=-abs(integer(length(nalezeno))-length(hledano)); {cim vetsi rozdil, tim nizsi skore}
  if length(nalezeno)>length(hledano) then delka:=length(hledano) else delka:=length(nalezeno);
  for a:=1 to delka do if nalezeno[a]=hledano[a] then inc(hodnoceni);
  for a:=1 to pocet_nej do if hodnoceni>nejlepsi[a].hodnoceni then
  begin
    vloz(nalezeno,hodnoceni,a);
    exit;
  end;
  if pocet_nej<10 then
  begin
    inc(pocet_nej);
    nejlepsi[pocet_nej].tvar:=nalezeno;
    nejlepsi[pocet_nej].hodnoceni:=hodnoceni;
  end;
end;

function nalezeno(co: string): boolean; {hleda ve slovniku "co"}
var s,srovnani: string;
    sl: pointer;
begin
  nalezeno:=false;
  srovnani:=ansilowercase(co);
  sl:=pointer(prvni);
  pocet_nej:=0;
  repeat
    s:=nacti_slovo(sl);
    if (s=co) or (s=srovnani) then {neuzna to vlastni jmena s malym pismenem}
    begin
      nalezeno:=true;
      exit;
    end else pridej_nejlepsi(s,co);
  until sl=nil;
end;

function otevri_vstup(jaky: string): boolean;
begin
  try
    assign(vstup,jaky);
    reset(vstup);
    result:=true;
  except;
    result:=false;
  end;
end;

function otevri_vystup(jaky: string): boolean;
begin
  try
    assign(vystup,jaky);
    rewrite(vystup);
    result:=true;
  except;
    result:=false;
  end;
end;

procedure zkontroluj(svstup,svystup: string);
var veta, kus: string;
    index: integer;
    typ: TTyp;
begin
  if not otevri_vystup(svystup) then exit;
  if not otevri_vstup(svstup) then
  begin
    writeln(vystup,'Vstupn soubor nenalezen');
    close(vystup);
    exit;
  end;
  Nacti_slovnik;
  while not eof(vstup) do
  begin
    readln(vstup,veta);
    index:=1;
    while sekej(veta,index,kus,typ) do
    if typ=slovo then
      begin
        if nalezeno(kus) then
          write(vystup,kus) else write(vystup,'#',kus);
      end else write(vystup,kus);
    writeln(vystup);
  end;
  Zrus_slovnik;
  close(vstup);
  close(vystup);
end;

function ignorovat(co: string): boolean;
var a: integer;
begin
  result:=false;
  for a:=1 to akt_ign do if co=ignorace[a] then begin result:=true; exit; end;
end;

procedure kontroluj_viz;
var veta,kus: string;
    index,a: integer;
    typ: TTyp;
begin
  while not eof(vstup) do
  begin
    readln(vstup,veta);
    index:=1;
    while sekej(veta,index,kus,typ) do
    if typ=slovo then
      begin
        if ignorovat(kus) or nalezeno(kus) then
          write(vystup,kus) else
        begin
          nalezena_chyba:=true;
          otazka.label4.caption:=kus;
          otazka.eVeta.text:=veta;
          otazka.cTvar.Clear;
          for a:=1 to pocet_nej do otazka.cTvar.Items.Add(nejlepsi[a].tvar);
          otazka.cTvar.text:=nejlepsi[1].tvar;
          case otazka.ShowModal of
               mrYes: write(vystup,otazka.cTvar.text);
               mrIgnore: begin
                           write(vystup,kus);
                         end;
               mrYesToAll: begin {ignorovat vse}
                             inc(akt_ign);
                             ignorace[akt_ign]:=kus;
                             if akt_ign=max_ign then otazka.button3.enabled:=false;
                             write(vystup,kus);
                           end;
               mrAll: begin {pridani do slovniku}
                        pridej_slovo(kus);
                        write(vystup,kus);
                      end;
               mrCancel: exit;
          end;

        end;
      end else write(vystup,kus);
    writeln(vystup);
  end;
end;

procedure TKontrola.Button1Click(Sender: TObject);
begin
  if not otevri_vstup(eVstup.text) then
  begin
    MessageDlg('Vstupn soubor nenalezen',mtError,[mbOk],0);
    exit;
  end;
  if not otevri_vystup(eVystup.text) then
  begin
    MessageDlg('Chyba pri otvirani vystupniho souboru',mtError,[mbOk],0);
    system.close(vstup);
    exit;
  end;
  akt_ign:=0;
  otazka.button3.enabled:=true;
  nalezena_chyba:=false;
  kontroluj_viz;
  if nalezena_chyba then MessageDlg('Kontrola pravopisu ukonena',mtInformation,[mbOk],0) else
                         MessageDlg('Nenalezena dn chyba',mtInformation,[mbOk],0);
  system.close(vstup); system.close(vystup);
end;

procedure TKontrola.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if slovnik_zmenen then zapis_slovnik;
  Zrus_slovnik;
end;

procedure TKontrola.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TKontrola.FormShow(Sender: TObject);
begin
  Nacti_slovnik;
  Info.ShowModal;
end;

end.
